/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* Autor: Welbert Gonalves Moitinha                                          */
/* Data: 21/09/2007                                                           */
/* Descrio:                                                                 */
/*    Gerar sugesto a partir de pedidos em andamento com as situaes        */
/*    Pedente, Confirmado e aprovado.                                         */
/*----------------------------------------------------------------------------*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GERA_SUGESTAO_COMPRA_PED ' AND
                 TYPE = 'P' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP PROCEDURE GERA_SUGESTAO_COMPRA_PED
GO

CREATE PROCEDURE GERA_SUGESTAO_COMPRA_PED (@P_CDFILIAL     VARCHAR(4),
                                           @P_CDOPERADOR   VARCHAR(12),
                                           @P_DTPEDINI     DATETIME,
                                           @P_DTPEDFIN     DATETIME,
                                           @P_DTENTINI     DATETIME,
                                           @P_DTENTFIN     DATETIME,
                                           @P_IDSITITEMPED VARCHAR(10),
                                           @P_CDFILIDEST   VARCHAR(300),
                                           @P_CDCLIENTE    VARCHAR(300),
                                           @P_IDGERASOLCMP VARCHAR(1),
                                           @P_NRSUGCOMPRA  VARCHAR(20),
                                           @P_CDPRODINI    VARCHAR(20),
                                           @P_CDPRODFIN    VARCHAR(20),
                                           @P_DTENTSOLI    DATETIME,
                                           @P_IDMENSSOLI   VARCHAR(10)OUTPUT)
AS
BEGIN
   DECLARE @V_NRITESUGCOMP INTEGER;
   DECLARE @V_QTCOMPRA     DOUBLE PRECISION;
   DECLARE @V_IDMENSSOLI   VARCHAR(1);
   DECLARE @C_REG_QTPEDIDO    DOUBLE PRECISION;
   DECLARE @C_REG_QTESTSEGU   DOUBLE PRECISION;
   DECLARE @C_REG_QTPREVICOMP DOUBLE PRECISION;
   DECLARE @C_REG_QTSOLICITA  DOUBLE PRECISION;
   DECLARE @C_REG_QTESTPRODUTO  DOUBLE PRECISION;
   DECLARE @C_REG_CDPRODUTO  VARCHAR(10);
   DECLARE @V_DTCORRENT DATETIME;
   DECLARE @V_CDPRODUTO   VARCHAR(10);
   DECLARE @V_CDARVPROD   VARCHAR(20);
   DECLARE @C_CDFILSUGCOMP VARCHAR(4);
   DECLARE @C_QTCOMPRA      DOUBLE PRECISION;
   DECLARE @C_CDPROSUGCOMP  VARCHAR(10);
   DECLARE @V_NRPREVCOMP    VARCHAR(20);
   DECLARE @V_NRSEQPREVI INTEGER;
   DECLARE @V_GEROU_SOLI INTEGER;
   DECLARE @V_PROXCODIGO VARCHAR(20);
   DECLARE @V_QTSAIDAANT  DOUBLE PRECISION;

   SET @V_DTCORRENT = GETDATE();
   SET @V_NRITESUGCOMP = 1;
   SET @V_PROXCODIGO = '';

   DECLARE C_REG CURSOR FOR
   SELECT SUM(B.QTPEDIDO), SUM(B.QTESTSEGU), SUM(B.QTPREVICOMP), SUM(B.QTSOLICITA), SUM(B.QTESTPRODUTO) 
     FROM( 
                  SELECT DISTINCT (I.QTITEMPED - I.QTEXPITEMPED) AS QTPEDIDO,
                  
                       (ISNULL((SELECT QTESTOSEGU
                                     FROM ESTOSEGU
                                    WHERE CDFILIAL = I.CDFILIAL 
                                      AND CDPRODESTO = U.CDPRODESTO), 0)) AS QTESTSEGU,

                       (ISNULL((SELECT (ISNULL(QTPREVCOMP,0))
                                     FROM ITPREVCOMP C
                                    WHERE C.IDSTITPRCOMP = ('A')      
                                      AND ((C.DTENTPRECOMP BETWEEN @P_DTENTINI  AND @P_DTENTFIN)OR((@P_DTENTINI IS NULL) AND(@P_DTENTFIN IS NULL)))
                                      AND I.CDFILIAL   = C.CDFILIAL  
                                      AND I.CDPRODUTO  = C.CDPRODUTO),0)) AS QTPREVICOMP,

                       (ISNULL((SELECT (ISNULL(IL.QTSOLIPROD,0))
                                     FROM SOLICITA S, ITEMSOLI IL
                                    WHERE I.CDFILIAL  = IL.CDFILSOLI 
                                      AND I.CDPRODUTO = IL.CDPRODUTO
                                      AND IL.IDSOLIAPROV = 'S'
                                      AND (S.IDBAIXASOL IS NULL)
                                      AND ((IL.DTPROGENTR BETWEEN @P_DTENTINI  AND @P_DTENTFIN)OR((@P_DTENTINI IS NULL) AND(@P_DTENTFIN IS NULL)))
                                      AND IL.CDFILSOLI  = S.CDFILSOLI    
                                      AND IL.CDFILLAN   = S.CDFILLANCA   
                                      AND IL.NRSOLICMP  = S.NRSOLICMP), 0)) AS QTSOLICITA,

                       (ISNULL((SELECT (ISNULL(QTTOTALESTOQ,0))* ISNULL(U.VRFATOCONV, 1)
                                     FROM POSESTATU PA
                                    WHERE I.CDFILIAL   = PA.CDFILIAL  
                                      AND I.CDPRODUTO  = PA.CDPRODUTO 
                                      AND PA.CDALMOXARIFE =  TEKNISA.BUSCA_ALMOX(I.CDFILIAL, '', I.CDPRODUTO)
                                      AND PA.CDLOCALESTOQ =  TEKNISA.BUSCA_LOCAL(I.CDFILIAL,'', I.CDPRODUTO )),0)) AS QTESTPRODUTO,
                       I.CDPRODUTO, U.CDARVPROD
                FROM
                   PRODUTO U, 
                   (SELECT IT.CDFILIAL, IT.CDPRODUTO, 
                           SUM(IT.QTITEMPED) AS QTITEMPED, SUM(IT.QTEXPITEMPED) AS QTEXPITEMPED
                      FROM PEDIDO P, ITEMPEDIDO IT, PRODUTO PR 
                     WHERE PR.CDARVPROD BETWEEN @P_CDPRODINI AND @P_CDPRODFIN
                       AND ((CONVERT(DATETIME, IT.DTENTITPED, 103) BETWEEN @P_DTENTINI  AND @P_DTENTFIN)OR((@P_DTENTINI IS NULL) AND(@P_DTENTFIN IS NULL)))
                       AND (CHARINDEX(IT.IDSITITEMPED, @P_IDSITITEMPED) > 0)
                       AND IT.CDPRODUTO = PR.CDPRODUTO 
                       AND IT.CDFILIAL = P.CDFILIAL
                       AND IT.NRPEDIDO = P.NRPEDIDO
                       AND P.CDFILIAL =  @P_CDFILIAL  
                       AND P.IDSITPEDIDO IN( '1','2','3','6') 
                       AND ((P.DTPEDIDO BETWEEN @P_DTPEDINI  AND @P_DTPEDFIN)OR((@P_DTPEDINI IS NULL) AND(@P_DTPEDFIN IS NULL)))
                       AND ((@P_CDCLIENTE IS NULL)OR(CHARINDEX(P.CDCLIENTE, @P_CDCLIENTE)>0))
                       AND ((@P_CDFILIDEST IS NULL)OR(CHARINDEX(P.CDFILIALPED, @P_CDFILIDEST)>0))
                       AND NOT EXISTS(SELECT K.NRPEDIDO
                                        FROM PEDIDOP K
                                       WHERE K.CDFILIAL = IT.CDFILIAL 
                                         AND K.NRPEDIDO = IT.NRPEDIDO 
                                         AND K.NRITEMPED = IT.NRITEMPED)
                      GROUP BY IT.CDFILIAL, IT.CDPRODUTO)  I  
                WHERE
                   U.CDARVPROD BETWEEN @P_CDPRODINI AND @P_CDPRODFIN AND
                   I.CDPRODUTO = U.CDPRODUTO) B
                GROUP BY B.CDARVPROD
                ORDER BY B.CDARVPROD;
   OPEN C_REG;
   FETCH NEXT FROM C_REG INTO @C_REG_QTPEDIDO, @C_REG_QTESTSEGU, @C_REG_QTPREVICOMP, @C_REG_QTSOLICITA,  @C_REG_QTESTPRODUTO, @C_REG_CDPRODUTO,@V_CDARVPROD;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_QTCOMPRA = (@C_REG_QTESTPRODUTO + @C_REG_QTSOLICITA + @C_REG_QTPREVICOMP) - ( @C_REG_QTPEDIDO  + @C_REG_QTESTSEGU);

       IF @V_QTCOMPRA > 0 BEGIN
          SET @V_QTCOMPRA = 0;
       END
       ELSE BEGIN
          SET @V_QTCOMPRA = @V_QTCOMPRA *(-1);
       END;

       IF @C_REG_QTPEDIDO > 0 BEGIN
          SET @V_QTSAIDAANT = @C_REG_QTPEDIDO;
       END
       ELSE BEGIN
          SET @V_QTSAIDAANT = 0;
       END;

       INSERT INTO TRAB_SUGCOMPRA
                       (CDFILSUGCOMP, NRSUGCOMPRA, CDPROSUGCOMP, DTREFSUGCOMP, QTCOMPRA,
                        QTSAIDAANT01, QTSAIDAANT02, QTSAIDAANT03, QTSAIDAATUAL, QTMEDIAMES, NRITESUGCOMP)
       VALUES
         (@P_CDFILIAL ,@P_NRSUGCOMPRA, @C_REG_CDPRODUTO, GETDATE(), @V_QTCOMPRA,
          @V_QTSAIDAANT, @C_REG_QTESTPRODUTO, @C_REG_QTESTSEGU, @C_REG_QTSOLICITA, @C_REG_QTPREVICOMP, RIGHT(REPLICATE ('0',10) + CONVERT(VARCHAR, @V_NRITESUGCOMP),10));


      SET @V_NRITESUGCOMP = @V_NRITESUGCOMP + 1;

      FETCH NEXT FROM C_REG INTO @C_REG_QTPEDIDO, @C_REG_QTESTSEGU, @C_REG_QTPREVICOMP, @C_REG_QTSOLICITA,  @C_REG_QTESTPRODUTO, @C_REG_CDPRODUTO, @V_CDARVPROD;
   END;

   CLOSE C_REG;
   DEALLOCATE C_REG;

   IF @P_IDGERASOLCMP  = 'S' BEGIN
      SET @V_GEROU_SOLI = 0;
      SET @P_IDMENSSOLI = '';

      DECLARE C CURSOR FOR
                SELECT CDFILSUGCOMP, CDPROSUGCOMP, QTCOMPRA
                  FROM TRAB_SUGCOMPRA
                 WHERE CDFILSUGCOMP = @P_CDFILIAL 
                   AND NRSUGCOMPRA  = @P_NRSUGCOMPRA 
                   AND QTCOMPRA > 0;

      OPEN C;
      FETCH NEXT FROM C INTO  @C_CDFILSUGCOMP, @C_CDPROSUGCOMP, @C_QTCOMPRA;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_GEROU_SOLI = 0 BEGIN

            SET @V_PROXCODIGO = 'NRPREVCOMP'+@P_CDFILIAL;


            EXEC NOVO_CODIGO @V_PROXCODIGO , @P_SEQUENCIAL = @V_NRPREVCOMP OUTPUT, @P_QTDE = 1;
            SET @V_NRPREVCOMP = SUBSTRING(@V_NRPREVCOMP, 11, 10);

            INSERT INTO PREVCOMP
               (CDFILIAL, NRPREVCOMP, CDOPGERPRCOM, DTHRPREVCOMP, IDSTPREVCOMP)
            VALUES
               (@P_CDFILIAL, @V_NRPREVCOMP, @P_CDOPERADOR, GETDATE(), 'P');
            SET @V_GEROU_SOLI = 1;
         END;



         SELECT @V_NRSEQPREVI = ISNULL(MAX(NRITPREVCOMP), 0) + 1
           FROM ITPREVCOMP
          WHERE CDFILIAL   = @P_CDFILIAL 
            AND NRPREVCOMP = @V_NRPREVCOMP;

         INSERT INTO ITPREVCOMP
            (CDFILIAL, NRPREVCOMP, NRITPREVCOMP, CDPRODUTO,  DTENTPRECOMP, QTPREVCOMP)
         VALUES
            (@P_CDFILIAL, @V_NRPREVCOMP , RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR,
             @V_NRSEQPREVI), 4) , @C_CDPROSUGCOMP, @P_DTENTSOLI, @C_QTCOMPRA);

         FETCH NEXT FROM C INTO  @C_CDFILSUGCOMP, @C_CDPROSUGCOMP, @C_QTCOMPRA;
      END;

      CLOSE C;
      DEALLOCATE C;

      DELETE FROM  TRAB_SUGCOMPRA
       WHERE CDFILSUGCOMP = @P_CDFILIAL 
         AND NRSUGCOMPRA  = @P_NRSUGCOMPRA;

      IF @V_GEROU_SOLI = 1 BEGIN
         SET @P_IDMENSSOLI = @V_NRPREVCOMP;
      END
      ELSE BEGIN
         SET @P_IDMENSSOLI = '3';
      END;
   END;
END;
GO
-- VERSAO --
EXEC ATUVEROBJ 'GERA_SUGESTAO_COMPRA_PED','5.01.014';
GO

